# mahoney.sql was originally generated by the autoSql program, which also 
# generated mahoney.c and mahoney.h.  This creates the database representation of
# an object which can be loaded and saved from RAM in a fairly 
# automatic way.

#Tabular data from Paul Gray/Mahoney spread sheet
CREATE TABLE mahoney (
    empty varchar(255) not null,	# Always blank
    mtf int not null,	# mahoney id
    sameAs varchar(255) not null,	# comma sep list of ids
    geneName varchar(255) not null,	# HUGO name if available
    domain varchar(255) not null,	# Domain that marks it as a transcription factor
    genbank varchar(255) not null,	# genbank (including refSeq) ID
    locusId varchar(255) not null,	# locus link id
    unigene varchar(255) not null,	# unigene id
    fragSize varchar(255) not null,	# PCR product size
    linzyme varchar(255) not null,	# Restriction enzyme to linearize
    rnaPol varchar(255) not null,	# DNA->RNA enzyme, usually T7
    cloneVector varchar(255) not null,	# Cloning vector
    seqVerified varchar(255) not null,	# X if true
    startLoc varchar(255) not null,	# start base pair location
    endLoc varchar(255) not null,	# end base pair location
    fPrimer varchar(255) not null,	# Forward primer
    rPrimer varchar(255) not null,	# Reverse primer
    fAdaptor varchar(255) not null,	# Start adapter enzyme
    rAdaptor varchar(255) not null,	# End adapter enzyme
              #Indices
    PRIMARY KEY(empty)
);
